/*
 . startcd.narod.ru
*/

//***************************************************************
// This code is distributed under the GNU Public License
//		which can be found at http://www.gnu.org/licenses/gpl.txt
//***************************************************************

//25.12.2015 



#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h> /*F_CPU = 4000000; _delay_ms max = 65,535ms; _delay_us max = 192us */
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <avr/power.h>

#include "pin_macros.h"

#include "term_fi.h"
#include "uart.h"
//#include "sht10.h"
#include "table.h"
#include "lpwm.h"

/*
4000000 meg 
*/

#define MAX_LENGTH_REG	135//   
#define TRIAC_ON	1// power
#define TRIAC_OFF	220//

#define LOW_PWM_T_MIN	5
#define LOW_PWM_T_MAX	500

//#define TEST	D,0,H
//#define TESTIMP	{ON(TEST);OFF(TEST);}


ISR(TIMER2_COMPA_vect){//   
if (OCR2A<220){
	ON(TRIAC);
	_delay_us(27);
	OFF(TRIAC);
	}
}

ISR(INT0_vect)//   .
{
	//TCCR2=0;//(1<<CS22)|(1<<CS21)|(0<<CS20);//  256
	//SFIOR|=_BV(PSR2);// Bit 0  PSR10: Prescaler Reset Timer/Counter1 and Timer/Counter0
	GTCCR|=_BV(PSRASY);//Bit 1  PSRASY: Prescaler Reset Timer/Counter2
	TCNT2=0;
	OCR2A=TriacGate;
	//TCCR2=(1<<CS22)|(1<<CS21)|(0<<CS20);//  256
	
}

static void avr_init(void)
{
	//TCCR0=_BV(CS00);
	TCCR1B=(1<<CS10)|(1<<WGM12);// ctc mode
	
	
	//MCUCR=(1<<ISC01)|(0<<ISC00);//1 1 The rising edge  //1 0 The falling edge of INT1 generates an interrupt request.
	//GICR=_BV(INT0);//External Interrupt Request 0 Enable
	EICRA=(1<<ISC01)|(0<<ISC00);//1 1 The rising edge  //1 0 The falling edge of INT1 generates an interrupt request.
	EIMSK=_BV(INT0);//External Interrupt Request 0 Enable
	
	DDRZN=BITZN|SEGZ_1|SEGZ_2;//    gh  
	DDRLED=0xFF;	

	DRIVER(TRIAC,OUT);
	DRIVER(DATA,OUT);
	DRIVER(SHIFT,OUT);
	DRIVER(STORAGE,OUT);
	DRIVER(ALARM_LED,OUT);
//	DRIVER(SCK,OUT);
	
	TIMSK2=_BV(OCIE2A);
	OCR1A=4000;// 1 
	OCR2A=220;//156 ~= 10mSek, 220 -   , TCNT2     ,    ISR(SIG_INTERRUPT0)
	TCCR2B=(1<<CS22)|(1<<CS21)|(0<<CS20);//  256
	
	sei();

    return;
}
//-------------------EEPROM-------------------------
static inline unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEPE));
	EEAR = uiAddress;
	EECR |= (1<<EERE);
	return EEDR;
}

static void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	if ( EEPROM_read(uiAddress)!=ucData){
		while(EECR & (1<<EEPE));
		cli();
		wdt_reset();//asm("wdr");//  
		EEAR = uiAddress;
		EEDR = ucData;
		EECR |= (1<<EEMPE);
		EECR |= (1<<EEPE);
		sei();
		}
}

static void read_data_EEPROM(void)
{
unsigned char  *a, i, adr;
unsigned int crc=0;
	a=(unsigned char *)&setup;
	for( i=0, adr=ADR_EEP ; i<sizeof(setup); i++, a++, adr++){
		*a=EEPROM_read(adr);
		if (i<sizeof(setup)-2){
			crc^=*a;
			}
		}
	if ( crc!=setup.crc ) {
		eeprom_err=2;
		setup.correction_ds[0]=0;
		setup.correction_ds[1]=0;
		setup.correction_ds[2]=0;
		setup.porog=(int16_t)(37.5*16);
		setup.AlarmT=(int16_t)(40*16);
		setup.DeltaT=0;
		setup.DeltaTGist=(int16_t)(0.5*16);
		setup.vlagnost=50;
		setup.time_lotok_pause=120;	//    ( 2 )
		setup.time_lotok_on=500;	//     0.1 
		setup.TimeOnVlagnost=50;	// 0.1 
		setup.TimePauseVlagnost=300;	// 0.1 
		setup.TimePauseProvetrivanie=30;	//   
		setup.TimeOnProvetrivanie=0;	// 1 
		setup.TimeOnOhlagdenie=0;	//   
		setup.TimePauseOhlagdenie=0;	//     
		setup.TemperatureOhlagdenie=setup.AlarmT;//      	
		setup.VlagnostDownFan=0;	//  ,     .
		#ifdef LOW_PWM
		setup.PowerConstTime=100;
		#else
		setup.PowerConstTime=0;
		#endif
		}
		//else {}

	porog=setup.porog;
	if ( porog<(uint16_t)(35*16) ) {
		eeprom_err=1;
		}

	
	if (eeprom_err) alarm_T|=ALRM_EEP;
	Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//   
	#ifdef LOW_PWM
	OnOutTime=setup.PowerConstTime;
	#endif	
}

static void EEPROM_save_parametr_all( void )
{
 unsigned char i, *p, adr;
 
	setup.crc=eeprom_err=alarm_T=0;
	p=(unsigned char *) &setup;
	for(i=0, adr=ADR_EEP; i<sizeof(setup) ; i++, p++, adr++){
		EEPROM_write( adr, *p );
		if (i<sizeof(setup)-2)
			setup.crc^=*p;
		}
}
//-------------END------EEPROM----------------------


//**********1wire************

static unsigned char readbit(void){
unsigned char i;
	cli();
	//DDR_1wire|=PWIRE_0;//line down
	//DDR_1wire|=PWIRE_1;//line down
	//DDR_1wire|=PWIRE_2;//line down
	DDR_1wire|=PWIRE_0|PWIRE_1|PWIRE_2;

	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");//1.25us
	
	//DDR_1wire&=~PWIRE_0;//line up through 1.25us
	//DDR_1wire&=~PWIRE_1;//line up through 1.25us
	DDR_1wire&=~(PWIRE_0|PWIRE_1|PWIRE_2);
	_delay_us(11);
	i=PIN_1wire;
	sei();
	_delay_us(47);
	return i;
}

static void readbyte(unsigned char *pw0) {
uint8_t rezult_0=0, rezult_1=0, rezult_2=0;

DDR_1wire&=~(PWIRE_0|PWIRE_1|PWIRE_2);
PORT_1wire&=~(PWIRE_0|PWIRE_1|PWIRE_2);
	//DDR_1wire&=~PWIRE_0;
	//DDR_1wire&=~PWIRE_1;
	//DDR_1wire&=~PWIRE_2;
	//PORT_1wire&=~PWIRE_0;
	//PORT_1wire&=~PWIRE_1;
	//PORT_1wire&=~PWIRE_2;


	for(uint8_t i=0, r=1; i<8; i++){
		uint8_t p=readbit();
		if ( p & PWIRE_0 ) rezult_0|=r;
		if ( p & PWIRE_1 ) rezult_1|=r;
		if ( p & PWIRE_2 ) rezult_2|=r;
		r<<=1;	
		}
	PORT_1wire|=out_1wire;
	DDR_1wire |=out_1wire;
	pw0[0]=rezult_0;
	pw0[1]=rezult_1;
	pw0[2]=rezult_2;
}

static void writebit0(void){
	cli();
	DDR_1wire|=PWIRE_0;//line down
	DDR_1wire|=PWIRE_1;//line down
	DDR_1wire|=PWIRE_2;//line down
	//DDR_1wire|=PWIRE_0|PWIRE_1|PWIRE_2;
	_delay_us(60);
	//DDR_1wire&=~(PWIRE_0|PWIRE_1|PWIRE_2);
	DDR_1wire&=~PWIRE_0;//line up 
	DDR_1wire&=~PWIRE_1;//line up 
	DDR_1wire&=~PWIRE_2;//line up 
	sei();
}

static void writebit1(void){
	cli();
	DDR_1wire|=PWIRE_0;//line down
	DDR_1wire|=PWIRE_1;//line down
	DDR_1wire|=PWIRE_2;//line down
	//DDR_1wire|=PWIRE_0|PWIRE_1|PWIRE_2;
	_delay_us(3);
	//DDR_1wire&=~(PWIRE_0|PWIRE_1|PWIRE_2);
	DDR_1wire&=~PWIRE_0;//line up 
	DDR_1wire&=~PWIRE_1;//line up
	DDR_1wire&=~PWIRE_2;//line up
	sei();
	_delay_us(58);
}

static void writebyte(unsigned char byte){
unsigned char i;
	DDR_1wire&=~PWIRE_0;
	DDR_1wire&=~PWIRE_1;
	DDR_1wire&=~PWIRE_2;
	PORT_1wire&=~PWIRE_0;
	PORT_1wire&=~PWIRE_1;
	PORT_1wire&=~PWIRE_2;
	
	for(i=0; i<8; i++){
		if ( byte & _BV(0) )
			writebit1();
			else
			writebit0();
		byte>>=1;
		}
	PORT_1wire|=out_1wire;
	DDR_1wire |=out_1wire;
}

void detectPresence(void){
unsigned char i;
	//pullup_off();
	DDR_1wire&=~PWIRE_0;
	DDR_1wire&=~PWIRE_1;
	DDR_1wire&=~PWIRE_2;
	PORT_1wire&=~PWIRE_0;
	PORT_1wire&=~PWIRE_1;
	PORT_1wire&=~PWIRE_2;
	out_1wire=PWIRE_0|PWIRE_1|PWIRE_2;
	
	DDR_1wire|=PWIRE_0;
	DDR_1wire|=PWIRE_1;	
	DDR_1wire|=PWIRE_2;
	_delay_ms(0.48);
	cli();
	DDR_1wire&=~PWIRE_0;
	DDR_1wire&=~PWIRE_1;	
	DDR_1wire&=~PWIRE_2;
	_delay_us(60);
	i=PIN_1wire;
	sei();
	
	if ( i & PWIRE_0 ) {
		out_1wire=PWIRE_1|PWIRE_2; 
		Outs_HC595 &=~OUT_DIFFERENCE_T;//Outs_HC595 |= OUT_ALARM_LED; 
		ON(ALARM_LED);
		} 
	if ( i & PWIRE_1 ) {
		out_1wire&=~PWIRE_1; 
		Outs_HC595&=~OUT_DIFFERENCE_T;//Outs_HC595 |= OUT_ALARM_LED;
		ON(ALARM_LED);
		}
	if ( i & PWIRE_2 ) {
		out_1wire&=~PWIRE_2; 
		on_out_vlagnost=0;
		//Outs_HC595&=~OUT_VLAG;
		FlagSHT10=on_out_vlagnost=Sht10Humi=0;
		ON(ALARM_LED);
		}
		
	if ( out_1wire ){
		_delay_ms(0.27);
		i=PIN_1wire;
		if (( i & PWIRE_0 )==0) {
			out_1wire&=~PWIRE_0; //out_1wire=PWIRE_1|PWIRE_2;
			Outs_HC595 &=~OUT_DIFFERENCE_T;//Outs_HC595 |= OUT_ALARM_LED; 			
			ON(ALARM_LED); 
			}
		if (( i & PWIRE_1 )==0) {
			out_1wire&=~PWIRE_1; 
			Outs_HC595&=~OUT_DIFFERENCE_T;
			ON(ALARM_LED);
			}
		if (!( i & PWIRE_2 )) {
			out_1wire&=~PWIRE_2; 
			on_out_vlagnost=0;
			//Outs_HC595&=~OUT_VLAG;
			FlagSHT10=on_out_vlagnost=Sht10Humi=0;
			ON(ALARM_LED);
			}
		PORT_1wire|=out_1wire;
		DDR_1wire|=out_1wire;
		}
	
	if ( out_1wire==0 ){
		alarm_T|=ALRM_SENS; //!  
		state_wire=0;//   
		TriacGate=TRIAC_OFF;
		//OFF(TRIAC);
		on_out_vlagnost=0;
		Outs_HC595&=~(OUT_DIFFERENCE_T|OUT_ON_NAGREV|OUT_DAMAGE_COOL|OUT_VLAG);
		//Outs_HC595&=~OUT_ON_NAGREV;
		//Outs_HC595&=~OUT_DAMAGE_COOL;
		//Outs_HC595&=~OUT_VLAG;
		}
}
//*******end***1wire************

static void SendUartStr(void){
	UartTxStr.OutsHC595=Outs_HC595;
	UartTxStr.Data.i16[0]=Temp_DS0;
	UartTxStr.Data.i16[1]=Temp_DS1;
	UartTxStr.Data.i16[2]=Temp_DS2;
	uart_puts_str();
}

void TValid(uint8_t i, int16_t *Temp){
static uint8_t TErrCount[3];
static int16_t Told[3];
int16_t t;
	t=( ((unsigned int)(temperature[i+3]<<8))|temperature[i] )+setup.correction_ds[i];// 

	if ( t> (Told[i]+10*16) ){
		if (++TErrCount[i]>=3){
			TErrCount[i]=0;
			Told[i]=t;
			*Temp=t;
			}
		}else{
		TErrCount[i]=0;
		Told[i]=t;
		*Temp=t;	
		}
}

static void TAlarm(int16_t t){
	if ( t < (setup.porog-(uint16_t)(1.5*16)) ) alarm_T|=ALRM_LOW_T;//     1,5  
	if (status_nagrev==5) alarm_T&= ~ALRM_LOW_T;// ,  .
	if ( t > setup.AlarmT-(int16_t)(0.5*16) ) alarm_T|=ALRM_HI_T;//    1 
	
	/*if ( t < (int16_t)35*16 ) {
		if (porog>=(int16_t)35*16 ) alarm_T|=ALRM_LOW_T;//   35 
		if (status_nagrev==5) alarm_T&= ~ALRM_LOW_T;// ,  .
		}
	else{
		if ( t > setup.AlarmT-(int16_t)(0.5*16) ) alarm_T|=ALRM_HI_T;//    1 
		}
		*/
}

//**************************************************
void receive_t(void){

	if ( state_wire==0 )
	{
	state_wire=1;
	detectPresence();
	return;
	}
	
	if ( state_wire==1 )
	{
	state_wire=2;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0x44);//CONVERT T [44h]
	time_wire=11;

	return;
	}
	
	if ( state_wire==2 )
	{
	if (time_wire>100) state_wire=3;
	return;
	}

	if ( state_wire==3 )
	{
	state_wire=4;
	detectPresence();
	return;
	}
	
	if ( state_wire==4 )
	{
	state_wire=5;
	writebyte(0xCC);//SKIP ROM [CCh]
	writebyte(0xBE);//READ SCRATCHPAD [BEh]
	return;
	}
	
	if ( state_wire==5 )
	{
	state_wire=8;
	readbyte(&temperature[0]);
	readbyte(&temperature[3]);
	return;
	}
	
	
	if ( state_wire==8 )
	{
	state_wire=9;
	
	alarm_T&=~(ALRM_LOW_T|ALRM_HI_T|ALRM_DFRN_T|ALRM_SENS);
	
	if ( out_1wire & PWIRE_2 ){//   
		TValid(2,&Temp_DS2);
		}
		
	if ( out_1wire & PWIRE_1 ){//  
		TValid(1,&Temp_DS1);//
		TAlarm(Temp_DS1);
		}
		
	if ( (out_1wire & PWIRE_0)==0 ) {//  
		Temp_DS0=Temp_DS1;//   
		}
	else{//  
		TValid(0,&Temp_DS0);
		TAlarm(Temp_DS0);
		}
	
	if ( (out_1wire & PWIRE_1)==0 ) Temp_DS1=Temp_DS0;
	
	if ( (out_1wire&(PWIRE_0|PWIRE_1)) == (PWIRE_0|PWIRE_1) ){//   0  1
		int16_t T_df=Temp_DS0-Temp_DS1;
		
		if ( T_df < 0 ) T_df*=-1;

		if ( T_df >= (setup.DeltaT+setup.DeltaTGist) ) Outs_HC595|=OUT_DIFFERENCE_T;
		if ( T_df <= setup.DeltaT ) Outs_HC595&=~OUT_DIFFERENCE_T;

		if ( T_df >= ((int16_t)(1.5*16)+setup.DeltaT) ) alarm_T|=ALRM_DFRN_T;//      
		if (status_nagrev==5) alarm_T &= ~ALRM_DFRN_T;// ,  .
		}

	if ( out_1wire & (PWIRE_0|PWIRE_1) ){//      
		int16_t	T=Temp_DS0;
		if ( Temp_DS1 > Temp_DS0 ) T=Temp_DS1;
		if ( T > setup.AlarmT-(uint16_t)(0.5*16) ) {
			Outs_HC595|=OUT_DAMAGE_COOL;
			StateOutCool|=VL_DAMAGE_COOL;
			}
		if (StateOutCool & VL_DAMAGE_COOL)
			if ( T <= porog ){ 
				Outs_HC595&=~OUT_DAMAGE_COOL;
				StateOutCool&=~VL_DAMAGE_COOL;
				}
		if (StateOutCool & VL_OHLAGDENIE){
			if (T<setup.TemperatureOhlagdenie) 
				if ( (StateOutCool & VL_DAMAGE_COOL)==0 ) Outs_HC595&=~OUT_DAMAGE_COOL;//   ,    
			}
		}
	//----- -----------
	if (FlagSHT10==SHT10_OK){
		if (Sht10Humi<setup.vlagnost) on_out_vlagnost=1; else on_out_vlagnost=0;
		//,   10% 
		if ( Sht10Humi < setup.vlagnost-10) 	TimeVlagnostLowAlrm++; else TimeVlagnostLowAlrm=0;
		if ( TimeVlagnostLowAlrm >= 254)		alarm_T |= ALRM_HUMIDY_LOW;//254-5.5min
		if ( Sht10Humi >= setup.vlagnost-5 )	alarm_T &=~ALRM_HUMIDY_LOW;
	
		if (status_nagrev==5) on_out_vlagnost=0; //    ,       
		
		//    %,   .
		if (setup.VlagnostDownFan){//  
			if 	( (Sht10Humi >= setup.vlagnost+setup.VlagnostDownFan) && ((StateOutCool & VL_OHLAGDENIE)==0)  )
				{
				StateOutCool|=VL_LARGE_VLAG;
				Outs_HC595|=OUT_DAMAGE_COOL;
				}
			}
		if (StateOutCool & VL_LARGE_VLAG)
			if (Sht10Humi<=setup.vlagnost){
				StateOutCool &= ~VL_LARGE_VLAG;
				if ( (StateOutCool & (VL_DAMAGE_COOL|VL_OHLAGDENIE|VL_PROVETRIVANIE))==0 ) Outs_HC595&=~OUT_DAMAGE_COOL;//   ,    
				}
		}
		else{
		on_out_vlagnost=0;
		//     ,        
		if (StateOutCool & VL_LARGE_VLAG){
			StateOutCool &= ~VL_LARGE_VLAG;
			if ( (StateOutCool & (VL_DAMAGE_COOL|VL_OHLAGDENIE|VL_PROVETRIVANIE))==0 ) Outs_HC595&=~OUT_DAMAGE_COOL;//   ,    
			}
		}
	//------------------------------------
	
	if ( out_1wire != (PWIRE_0|PWIRE_1|PWIRE_2) ) alarm_T|=ALRM_SENS;//   
	
	
	if (( Temp_DS0 > setup.AlarmT ) || ( Temp_DS1 > setup.AlarmT ) )	//   ( )    (uint16_t) (40.5*16)
		{										
		Outs_HC595 |= OUT_SILOVOE_RELE; 
		Outs_HC595&=~OUT_ON_NAGREV;
		ON(ALARM_LED);
		alarm_T|=ALRM_REG_ALARM_RELE;//    
		TriacGate=TRIAC_OFF; 
		status_nagrev=4;
		Avaria=1;
		#ifdef LOW_PWM
		OnOutTime=300;
		TimPause=450;
		#endif
		}
	
	SendUartStr();
	return;
	}
	
	
	if ( state_wire==9 )
	{
	state_wire=10;
	int16_t	T=Temp_DS0;
	if ( Temp_DS1 > Temp_DS0 ) T=Temp_DS1;
//---------------------------------------------------------------------------------------------------------------------
#ifdef LOW_PWM
	//----------------------__----------------------------
	switch(status_nagrev)
	{
	case(0): 
	case(4):
		{
		regulyator(T, porog);
		if (Avaria) 
			if (TimPause<100) TimPause=100;
		break;
		}
	/*case(4):// 
		{
		if ( T < porog )
			{
			Outs_HC595 &= ~OUT_SILOVOE_RELE;
			Outs_HC595|=OUT_ON_NAGREV;
			TriacGate=TRIAC_ON;
			}
		else//	if ( Temp_DS0 >= porog )
			{
			Outs_HC595 |= OUT_SILOVOE_RELE;
			Outs_HC595&=~OUT_ON_NAGREV;
			TriacGate=TRIAC_OFF;
			}
		break;
		}*/
	case(5):
		{//    ,       
		TriacGate=TRIAC_OFF;
		Outs_HC595&=~(OUT_ON_NAGREV|OUT_SILOVOE_RELE);
		break;
		}
	default:
		if (Avaria==0)
			status_nagrev=0;//   . 
			else
			status_nagrev=4;
	}
#else
//---------------------------------------------------------------------------------------------------------------------
	//------------------- ---------------------------------
	switch(status_nagrev)
	{
	case(0):
		if	( T >= porog-(uint16_t)4*16 ) {	
			Old_Temperatura=T;
			//TriacGate=120;// .. OCR2 max 155   (10mSek)
			tmp_power=70;// tmp_power -    , TriacGate -  ,      tmp_power,     
			Outs_HC595|=OUT_ON_NAGREV;
			status_nagrev=1;	//   -4    
			}
		else{
			tmp_power=TriacGate=TRIAC_ON;//  
			Outs_HC595|=OUT_ON_NAGREV;
			}
		
		break;

	case(1):
		if ( T >= porog ){//   
			Old_Temperatura=0;
			tmp_power=70;
			TriacGate=TRIAC_OFF;
			Outs_HC595&=~OUT_ON_NAGREV;	
			status_nagrev=2;//        
			}
			else
			{
			if ( T > Old_Temperatura+1 )
				{
				if ( T > Old_Temperatura+2 ) 
					if ( tmp_power<100 ) tmp_power+=5;
				Old_Temperatura=T;
				TriacGate=130;//,   
				Outs_HC595&=~OUT_ON_NAGREV;
				}
				else
				{
				if (tmp_power>2) tmp_power-=2;//    ,  
				TriacGate=tmp_power;// 
				Outs_HC595|=OUT_ON_NAGREV;
				}
			}
		break;
	
	case(2):
		if ( T < porog ) 	//       time_power_off  
			status_nagrev=3;		//   3    50% 
			else
		break;

	case(3):
		if ( T <= porog )//  
			{
			#define T_NO_POWER	0	//    
			#define NAGREV_OFF	1	//   ,       
			#define T_BOTTOM	2	//  
			#define T_TOP		3
			
			if ( (power_flag==NAGREV_OFF)||(power_flag==T_NO_POWER) ) TriacGate=MAX_LENGTH_REG;//    ,      
			power_flag=T_BOTTOM;
			uint8_t inc=1;
			if ( T+1 < porog ) inc=2;
			if ( T+2 < porog ) inc=5;//      
			
			if ( T != porog )
				{if (tmp_power>inc) tmp_power-=inc; else tmp_power=1;}//  
			
			//TriacGate=tmp_power;//  main()
			Outs_HC595|=OUT_ON_NAGREV;
			}
		else  
		if ( T > porog )
			{//  
			if ( power_flag==T_BOTTOM ){
				if (tmp_power<80)//  ,   ,   ,     
					TriacGate=80;
				else 
				TriacGate=tmp_power;
				}
			power_flag=T_TOP;
			
			uint8_t inc=1;
			if ( T > porog+1 ) {
				power_flag=T_NO_POWER; 
				TriacGate=TRIAC_OFF;//  
				if ( T > porog+2 ) {inc=3;}
				}
			
			if (T>Old_Temperatura) {//      .
				if (tmp_power<MAX_LENGTH_REG) tmp_power+=inc;
				}
			Outs_HC595&=~OUT_ON_NAGREV;
			}

		Old_Temperatura=T;
		break;
	case(4)://  ,    
		if ( T < porog )
			{
			Outs_HC595 &= ~OUT_SILOVOE_RELE;
			Outs_HC595|=OUT_ON_NAGREV;
			TriacGate=TRIAC_ON;
			}
		else//	if ( Temp_DS0 >= porog )
			{
			Outs_HC595 |= OUT_SILOVOE_RELE;
			Outs_HC595&=~OUT_ON_NAGREV;
			TriacGate=TRIAC_OFF;
			} 
		break;
	case(5):
		{//    ,       
		TriacGate=TRIAC_OFF;
		Outs_HC595&=~(OUT_ON_NAGREV|OUT_SILOVOE_RELE);
		break;
		}
	}
#endif
	return;
	}

	
	if ( state_wire==10 )
	{
	state_wire=0;
	
	int16_t	T=Temp_DS0;
	if ( Temp_DS1 > Temp_DS0 ) T=Temp_DS1;
	//----------------
	if ( ( out_1wire & PWIRE_2 ) && (out_1wire & (PWIRE_0|PWIRE_1)) )
		{
		if (T >= 35*16 )//     35 
			{
			if (Temp_DS2 >= 24*16 )//     24 
				{
				uint8_t s,v;
				uint16_t T_table=(uint16_t)(43.5*16);//40*16;
				for(s=17; s!=0xFF; s--){//s=10
					if (T >= T_table)  break;
					T_table-=8;//0,5 
					}
				T_table=39*16;	
				for(v=30; v!=0xFF; v--){
					if (Temp_DS2 >= T_table)  break;
					T_table-=8;
					}
				Sht10Humi=pgm_read_byte_near(&table_vl[s][v]);//  
				FlagSHT10=SHT10_OK;
				//if (Vlagnost<=setup.vlagnost) on_out_vlagnost=1; else on_out_vlagnost=0;
				}
				else { Sht10Humi=0; FlagSHT10=SHT10_OK;}//    ,   ,  
			}
			else {FlagSHT10=on_out_vlagnost=Sht10Humi=0;}
		}
		else {FlagSHT10=on_out_vlagnost=Sht10Humi=0;}//  ,  
	}
}


//******************74hc595***********************************
static 
void data_shift(uint8_t data)
{
	for(uint8_t i=8; i ; i--){//   8 
		if (data & _BV(7) )		ON(DATA);
                    else		OFF(DATA); 
		data<<=1;
		_delay_us(3);
		ON(SHIFT);
		_delay_us(3);
		OFF(SHIFT);
	} 
}

static void hc595_out(void)
{
//	ON(STORAGE);//ON(ST_DISP);// 
	

#ifdef katod
	data_shift( led_buffer_vlag[znmesto] );
	data_shift( ~(0x02<<znmesto) );
#else
	data_shift( ~led_buffer_vlag[znmesto] );
	data_shift( 0x02<<znmesto );
#endif

	
	data_shift( Outs_HC595 );
	
	OFF(STORAGE);	//OFF(ST_DISP);
	_delay_us(3);
	ON(STORAGE);	//ON(ST_DISP);
	_delay_us(3);
	OFF(STORAGE);	//OFF(ST_DISP);
	OFF(DATA);
	OFF(SHIFT);
}




//**************************************
void result_in_bcd(int result)
{
    uint8_t dig_out=0;
	//bcd_num1=0;
	bcd_num2=0;
	bcd_num3=0;
	bcd_num4=0;

	//while (result >= 1000) {
	// result -= 1000;
 	// dig_out ++;
	//}
	//bcd_num1=dig_out;
    //dig_out = 0;
	while (result >= 100)  {
 	 result -= 100;
	 dig_out ++;
	 }
	bcd_num2=dig_out;
	dig_out = 0;
	while (result >= 10)   {
	 result -= 10;
	 dig_out ++;
	 }
	bcd_num3=dig_out;
	bcd_num4=result;
}
//**************************************
void t_in_bcd(signed int t, unsigned char pin_wire){

	 if ( !(pin_wire & out_1wire) ){
	 	led_buffer[0]=sG;
		led_buffer[1]=sG;
		led_buffer[2]=sG;
		}
		else
		{

		result_in_bcd( (t*5+2)/8 );
		
		if ( bcd_num2 ){ 
			led_buffer[0]=font[bcd_num2]; 
			}

		led_buffer[1]=font[bcd_num3]|sH; 
		led_buffer[2]=font[bcd_num4]; 
		}
}

//-------------------------------------
static void led_off(void)
{
	// 
#ifdef katod
	PORTZN |= ZN0;
	PORTZN |= ZN1;
	PORTZN |= ZN2;
	PORTZN &= ~SEGZ_1;
	PORTZN &= ~SEGZ_2;
	//PORTLED=0;
	PORTLED&=_BV(6)|_BV(7);//xx00 0000
#else
	PORTZN &= ~ZN0;
	PORTZN &= ~ZN1;
	PORTZN &= ~ZN2;
	PORTZN |= SEGZ_1;
	PORTZN |= SEGZ_2;
	//PORTLED=0xFF;
	PORTLED|=~(_BV(6)|_BV(7));//xx11 1111
#endif
}

//-------------------------------------
static void led_on(void)
{
#ifdef katod
	if ( znmesto==0 )	PORTZN &= ~ZN0;
	else
	if ( znmesto==1 )	PORTZN &= ~ZN1;
	else
	if ( znmesto==2 )	PORTZN &= ~ZN2;
	//PORTLED=led_buffer[znmesto];
	PORTLED|=led_buffer[znmesto]&(~(_BV(6)|_BV(7)));
	if ( led_buffer[znmesto] & _BV(6) ) PORTZN |= SEGZ_1;
	if ( led_buffer[znmesto] & _BV(7) ) PORTZN |= SEGZ_2;
#else
	if ( znmesto==0 )	PORTZN |= ZN0;
	else
	if ( znmesto==1 )	PORTZN |= ZN1;
	else
	if ( znmesto==2 )	PORTZN |= ZN2;
	//PORTLED=~led_buffer[znmesto];
	PORTLED&=~ ( led_buffer[znmesto]&(~(_BV(6)|_BV(7))) );
	if ( led_buffer[znmesto] & _BV(6) ) PORTZN &= ~SEGZ_1;
	if ( led_buffer[znmesto] & _BV(7) ) PORTZN &= ~SEGZ_2;
#endif
}
//-------------------------------------
static void skan_key(void){
// 4mSek
#ifdef katod

#else
	PORTZN &= ~SEGZ_2;//   
#endif	
	PORTLED|=~(_BV(6)|_BV(7));//PORTLED=0xFF;	//   1
	DDRLED&=_BV(6)|_BV(7);//DDRLED=0;		// ,  .
	_delay_us(15);
	uint8_t pin=PINLED;
#ifdef katod
	PORTLED&=_BV(6)|_BV(7);//PORTLED=0;
#else
	PORTZN |= SEGZ_2;//   
#endif

	DDRLED|=~(_BV(6)|_BV(7));//DDRLED=0xFF;
//--------------------------------------
#define KEY_PRESS(key)	((pin & (key))==0)
#define KEY_T		7
#define KEY_PLUS	4
#define KEY_MINUS	5
//---------------------------------------------------------------------------------------	
	//static uint8_t antdr, count_press, povtor;
	if ( KEY_PRESS(BTN_TIME_OFF ) || KEY_PRESS(BTN_DS2 ) || KEY_PRESS(BTN_TEMPER) ){//    
		if ( antdr>=pause_after_press[count_press] ) antdr=0;
		if (++antdr==2){
			
			if ( KEY_PRESS(BTN_TIME_OFF ) && KEY_PRESS(BTN_DS2 ) && KEY_PRESS(BTN_TEMPER) )
				key=1;//  
			else
			if ( KEY_PRESS(BTN_TEMPER)  &&  KEY_PRESS(BTN_DS2) )
				key=2;//   
			else
			if ( KEY_PRESS(BTN_TIME_OFF) && KEY_PRESS(BTN_DS2) )
				key=3;//     
			else	
			if ( KEY_PRESS(BTN_TIME_OFF) )
				key=KEY_MINUS;//   
			else
			if ( KEY_PRESS(BTN_DS2 ) )
				key=KEY_PLUS;// ds2
			else
			if ( KEY_PRESS(BTN_TEMPER ) )
				key=KEY_T;// 
			
			if (count_press<sizeof(pause_after_press)-1) count_press++;
			if (++povtor>=sizeof(pause_after_press)+35) inc=5;
			}
		}
		else{
		if (antdr>10) antdr=10;
		if (antdr){
			if (--antdr==0){
				key=count_press=povtor=0;
				inc=1;
				}
			}
			else{
			key=count_press=povtor=0;
			inc=1;
			}
		}

//----------------------------
	static uint8_t antdr_swt_F;
	if ( KEY_PRESS(SWT_F_KONZEVIK) ){//  
		if (++antdr_swt_F>=25){//125-0.5 sek
			antdr_swt_F=3;
			swt_konzevik|=SWT_F_KONZEVIK;
			}
		}
		else{
		if (antdr_swt_F>3) antdr_swt_F=3;
		if (antdr_swt_F){
			if (--antdr_swt_F==0)	swt_konzevik &= ~SWT_F_KONZEVIK;
			}
			else{
			swt_konzevik &= ~SWT_F_KONZEVIK;
			}
		}
	//----------------------------
	static uint8_t antdr_swt_R;
	if ( KEY_PRESS(SWT_R_KONZEVIK) ){//  
		if (++antdr_swt_R>=25){//125-0.5 sek
			antdr_swt_R=3;
			swt_konzevik|=SWT_R_KONZEVIK;
			}
		}
		else{
		if (antdr_swt_R>3) antdr_swt_R=3;
		if (antdr_swt_R){
			if (--antdr_swt_R==0)	swt_konzevik &= ~SWT_R_KONZEVIK;
			}
			else{
			swt_konzevik &= ~SWT_R_KONZEVIK;
			}
		}
}

void param_edit(int16_t Toplimit, int16_t Bottomlimit, uint8_t inc){
	if (key==KEY_PLUS){
		if ( (tmp_int16+=inc)>Toplimit) tmp_int16=Bottomlimit;
		time_state=0;
		key=0;
		}
	if (key==KEY_MINUS){
		if ( (tmp_int16-=inc)<Bottomlimit) tmp_int16=Toplimit;
		time_state=0;
		key=0;
		}
}


//-------------------------------------
void key_action(void){
static int16_t *i16;

	switch (state)
	{
    case (0):
		if ( key ) 
		{
		state=ST_INPUT_REG; 
		time_state=0;
		}
		break;
    case (ST_INPUT_REG):
		if ( key ){
			show_vlagnost=0;
			ShowTimeMO=0;
			ShowAlarm=0;
			
			if (time_state>20){
				if (key==1) state=ST_COR_IN_DS0;//  
				else
				if (key==2) state=ST_FORCE_POVOROT;//   
				else
				if (key==3) state=ST_MANUAL_MOVE; //     
				else
				if (key==KEY_MINUS) state=ST_TIM_OFF;//   
				else
				if (key==KEY_PLUS) state=ST_SET_VLAG;// ds2
				else
				if (key==KEY_T) state=ST_SET_T;// 
				else
				state=0;
				
				}
				else
				{
				if (key==KEY_PLUS) show_vlagnost=1;	
				if (key==KEY_MINUS) ShowTimeMO=1;	
				if (key==KEY_T) ShowAlarm=1;	
				}
			}
			else {
			state=0;
			if (show_vlagnost) {time_state=0;	state=ST_SHOW_VLAGNOST;}
			if (ShowTimeMO)    {time_state=0;	state=ST_SHOW_TIME_MO;}
			if (ShowAlarm)    {time_state=0;	state=ST_SHOW_ALARM; ShowAlarm=0;}
			}
		break;

	//--------------------------------------
	case (ST_STORE_EEP):
		
		EEPROM_save_parametr_all();
		
		state=0;
		break;
	//--------------------------------------
	case (ST_TIM_OFF)://     
		if (key==0){
			alarm_T&=~ALRM_SWT_ERROR;
			state=ST_TIM_OFF_1; 
			time_state=0;
			tmp_int16=setup.time_lotok_pause;
			i16=&setup.time_lotok_pause;
			}
			else
			if (time_state>40)
			{
			state=ST_TIM_PROV_ON; 
			}
		break;

	case (ST_TIM_OFF_1):	//      10
		if (key==KEY_T) {
			tmp_int16=0; 
			time_state=0;
			}
		param_edit(599, 0, inc);		
		if (time_state>40) {// 4  ,     eeprom
			//       ST_TIM_PROV_ON
			if (i16==&setup.TimeOnProvetrivanie){
				Time_Provetrivanie=0;
				StateOutCool&=~VL_PROVETRIVANIE;
				}
			//       ST_TIM_PROV_OFF
			if (i16==&setup.TimePauseProvetrivanie){
				Time_Provetrivanie=0;
				StateOutCool |= VL_PROVETRIVANIE;
				}
			if ( i16 == &setup.time_lotok_pause ){
				if ( tmp_int16==0){
					state_motor=3;//
					Time_Motor=0;//   
					}
					else{
					if (state_motor==0) Time_Motor=(int32_t)tmp_int16*60*10;//  
					}
				}
			*i16=tmp_int16;
			state=ST_STORE_EEP;
			}
		break;
	//-------------------------------------------------
	case (ST_TIM_PROV_ON)://     
		if (key==0){
			state=ST_TIM_OFF_1; 
			time_state=0;
			tmp_int16=setup.TimeOnProvetrivanie;
			i16=&setup.TimeOnProvetrivanie;
			}
			else
			if (time_state>55)
			{
			state=ST_TIM_PROV_OFF; 
			}
		break;
	case (ST_TIM_PROV_OFF)://      
		if (key==0){
			state=ST_TIM_OFF_1; 
			time_state=0;
			tmp_int16=setup.TimePauseProvetrivanie;
			i16=&setup.TimePauseProvetrivanie;
			}
			else
			if (time_state>70)
			{
			state=ST_TIM_OHLAGD_ON; 
			}
		break;	
		
	case (ST_TIM_OHLAGD_ON)://      1-60
		if (key==0){
			state=ST_TIM_OHLAGD_EDIT; 
			time_state=0;
			tmp_int16=setup.TimeOnOhlagdenie;
			i16=&setup.TimeOnOhlagdenie;
			}
			else
			if (time_state>85)
			{
			state=ST_TIM_OHLAGD_OFF; 
			}
		break;	
	case (ST_TIM_OHLAGD_OFF)://       1-48
		if (key==0){
			state=ST_TIM_OHLAGD_EDIT; 
			time_state=0;
			tmp_int16=setup.TimePauseOhlagdenie;
			i16=&setup.TimePauseOhlagdenie;
			}
			else
			if (time_state>100)
			{
			state=ST_TIM_OHLAGD_TEMPER; 
			}
		break;	
	case (ST_TIM_OHLAGD_TEMPER)://        
		if (key==0){
			state=ST_SET_T_1; 
			time_state=0;
			tmp_int16=(setup.TemperatureOhlagdenie*5+2)/8; 
			i16=&setup.TemperatureOhlagdenie;
			}
		break;	
		
	case (ST_TIM_OHLAGD_EDIT):	//      10
		if (key==KEY_T) {tmp_int16=0; time_state=0;}
		param_edit(72, 0, 1);		
		if (time_state>40) {// 4  ,     eeprom
			//       ST_TIM_PROV_ON
			if (i16==&setup.TimeOnOhlagdenie){// 
				Time_Ohlagdenie=0;
				StateOutCool &=~VL_OHLAGDENIE;
				}
			//       ST_TIM_PROV_ON
			if (i16==&setup.TimePauseOhlagdenie){// 
				Time_Ohlagdenie=0;
				StateOutCool |= VL_OHLAGDENIE;
				}	
			*i16=tmp_int16;
			state=ST_STORE_EEP;
			}
		break;
	
	//-------------------------------------------------
	case (ST_MANUAL_MOVE):
		if (key==0) { time_state=0; tmp_int16=0; state=ST_MANUAL_MOVE_1;}//    
		break;
	case (ST_MANUAL_MOVE_1)://     12
		if (key==KEY_T) {state=ST_MANUAL_MOVE_2; time_state=0;}//  KEY_T     
		
		if (time_state>250) state=show_vlagnost=0;// 25  , 
		
		#if (defined (AKTUATOR)||defined (KSHM))
		if (key==KEY_PLUS){
			state_motor=1;// 
			time_state=0;
			}
		else
		if (key==KEY_MINUS){
			state_motor=2;//
			time_state=0;
			}
		else 
		if (state_motor<3) //  
			state_motor=3;//   
		#else
		if ( state_motor && (state_motor<3) ) 
			state_motor=3;//   
		
		if (key==KEY_PLUS){
			if ( (swt_konzevik & SWT_R_KONZEVIK)==0 ) 
				state_motor=1;// 
			time_state=0;
			}
		else
		if (key==KEY_MINUS){
			if ( (swt_konzevik & SWT_F_KONZEVIK)==0 ) 
				state_motor=2;//
			time_state=0;
			}
		#endif
		
		revers=1;//        .
		break;
	case (ST_MANUAL_MOVE_2)://13
		if (key==0) {
				tmp_int16=0;
				state=ST_MANUAL_MOVE_1;
				}
		if (time_state>30) {//  KEY_T    3,     
			Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  ,        
			#if (defined (AKTUATOR)||defined (KSHM))
			setup.time_lotok_on=	500;//    ,     .   OFF
										// AKTUATOR  KSHM    time_lotok_on 
			#else
			setup.time_lotok_on=	tmp_int16;
			#endif
			show_vlagnost=0;
			state=ST_STORE_EEP;
			}
		break;
	
	case (ST_FORCE_POVOROT)://    14
		#if defined(AKTUATOR)
		Time_Motor=1;
		#else
		if ( (Outs_HC595 & OUT_MOTOR)==0 )//   
			Time_Motor=1;
		#endif
		state=0;
		break;

	//------------------------------------------------------------
	case (ST_COR_IN_DS0)://  15
		if (key==0){
			state=ST_COR_1; 
			time_state=0;
			i16=&setup.correction_ds[0];
			}
			else
			if (time_state>40)
			{
			state=ST_COR_IN_DS1; 
			}
		break;
	
	case (ST_COR_IN_DS1)://  15
		if (key==0){
			state=ST_COR_1; 
			time_state=0;
			i16=&setup.correction_ds[1];
			}
		break;
	
	/*case (ST_COR_IN_DS1)://  15
		if (key==0){
			state=ST_COR_1; 
			time_state=0;
			i16=&setup.correction_ds[1];
			}
			else
			if (time_state>60)
			{
			state=ST_COR_IN_DS2; 
			}
		break;
	case (ST_COR_IN_DS2)://  15
		if (key==0){
			state=ST_COR_1; 
			time_state=0;
			i16=&setup.correction_ds[2];
			}
		break;*/
		
	case (ST_COR_1)://  15
		state=ST_COR_2;	
		if ( (*i16)>0 )
			tmp_int16=( (*i16)*5+2)/8; 
			else
			tmp_int16=( (*i16)*5-2)/8;
		break;
		
	//case (ST_COR_1):	//    
	case (ST_COR_2):		
		param_edit(99,-99, 1);
		if (time_state>40) {// 4  ,     eeprom
			
			if (tmp_int16>0)
				*i16=(tmp_int16*8+2)/5;
				else
				*i16=(tmp_int16*8-2)/5;
			state=ST_STORE_EEP;
			}
		break;
	
	//------ --ds0--------
	case (ST_SET_T)://
		if (key==0){
			state=ST_SET_T_1; 
			time_state=0;
			tmp_int16=(porog*5+2)/8; 
			i16=&setup.porog;
			}
			else
			if (time_state>40)
			{
			state=ST_SET_DELTA_T; 
			}
		break;
		
	case (ST_SET_DELTA_T): //       
		if (key==0) {
			state=ST_SET_DELTA_T_EDIT; 
			time_state=0;
			i16=&setup.DeltaT;
			tmp_int16=( (*i16)*5+2)/8; 
			}
			else
			if (time_state>60)
			{
			state=ST_SET_DELTA_T_GIST; 
			}
		break;
	case (ST_SET_DELTA_T_GIST): //          
		if (key==0) {
			state=ST_SET_DELTA_T_EDIT; 
			time_state=0;
			i16=&setup.DeltaTGist;
			tmp_int16=( (*i16)*5+2)/8; 
			}
			else
			if (time_state>80)
			{
			state=ST_SET_T_ALARM; 
			}
		break;
	case (ST_SET_DELTA_T_EDIT):		
		param_edit(30, 0, 1);
		if (time_state>40) {// 4  ,     eeprom
			*i16=(tmp_int16*8+2)/5;
			state=ST_STORE_EEP;
			}
		break;
		
	case (ST_SET_T_ALARM): //   
		if (key==0){
			tmp_int16=(setup.AlarmT*5+2)/8; 
			time_state=0; 
			state=ST_SET_T_ALARM_1;
			}
			#ifdef LOW_PWM
			else
			if (time_state>100)
			{
			state=ST_POWER_CONST; 
			}
			#endif
		break;	
		
	case (ST_SET_T_1):	//  
		param_edit( (setup.AlarmT*5+2)/8-3,200, 1);
		if (time_state>40) {// 4  ,     eeprom
			if ( i16 == &setup.porog ){
				porog=(tmp_int16*8+2)/5;
				if (Avaria==0)
					status_nagrev=0;//   . 
					else
					status_nagrev=4;
				}
			*i16=(tmp_int16*8+2)/5;
			state=ST_STORE_EEP;
			}
		break;
	case (ST_SET_T_ALARM_1):	//   
		param_edit( 450,370, 1);
		if (time_state>40) {// 4  ,     eeprom
			setup.AlarmT=(tmp_int16*8+2)/5;
			state=ST_STORE_EEP;
			}
		break;
#ifdef LOW_PWM
	case (ST_POWER_CONST):	//  
		if (key==0) {tmp_int16=setup.PowerConstTime; time_state=0; state=ST_POWER_CONST_1;}
		break;
	case (ST_POWER_CONST_1):	//   
		param_edit(LOW_PWM_T_MAX, LOW_PWM_T_MIN, inc);
		if (time_state>40) {// 4  ,     eeprom
			setup.PowerConstTime=tmp_int16;
			#ifdef LOW_PWM
			OnOutTime=tmp_int16;
			TimPause=0;
			#endif
			state=ST_STORE_EEP;
			}
		break;
#endif		
	//---------------------ds2--------------------------------------
	case (ST_SET_VLAG):// 
		if (key==0) { time_state=0; tmp_int16=setup.vlagnost; state=ST_SET_VLAG_POROG;}//  2  
		else
		if (time_state>40){
			state=ST_SET_VLAG_T_ON;
			}
		break;
		
	case (ST_SET_VLAG_POROG)://   
		param_edit( 98,17, 1);
		if (time_state>40) {// 4  ,     eeprom
			setup.vlagnost=tmp_int16;
			state=ST_STORE_EEP;
			}
		break;
	//-------------------------------------------------------------	
	case (ST_SET_VLAG_T_ON)://    
		if (key==0) { 
			time_state=0; 
			tmp_int16=setup.TimeOnVlagnost/10; 
			i16=&setup.TimeOnVlagnost; 
			state=ST_VLAG_WORK_EDIT;
			}
		else
		if (time_state>60){
			state=ST_SET_VLAG_PAUSE;
			}
		break;
	//-------------------------------------------------------------	
	case (ST_SET_VLAG_PAUSE)://    
		if (key==0) { 
			time_state=0; 
			tmp_int16=setup.TimePauseVlagnost/10; 
			i16=&setup.TimePauseVlagnost; 
			state=ST_VLAG_WORK_EDIT;
			}
		else
		if (time_state>80){
			state=ST_VLAG_DOWN;
			}	
		break;
	
	case (ST_VLAG_WORK_EDIT):
		param_edit( 200, 0, inc);
		if (time_state>40) {// 4  ,     eeprom
			*i16=tmp_int16*10;
			state=ST_STORE_EEP;
			}
		break;
	
	case (ST_VLAG_DOWN):// ""       
		if (key==0){
			state=ST_VLAG_DOWN_1; 
			time_state=0;
			tmp_int16=setup.VlagnostDownFan;
			i16=&setup.VlagnostDownFan;
			}
		break;	
		
	case (ST_VLAG_DOWN_1)://       
		param_edit( 50, 0, 1);
		if (time_state>40) {// 4  ,     eeprom
			*i16=tmp_int16;
			state=ST_STORE_EEP;
			}
		break;
	//-----------------------------------------------------------
	case (ST_SHOW_VLAGNOST)://2 ds
		if  (time_state>200) {show_vlagnost=state=0;}
		if (key) 
		{
		if (key==KEY_PLUS) {
			if (++show_vlagnost>=4){
				show_vlagnost=state=0;
				}
			key=time_state=0;
			}
			else
			show_vlagnost=state=0;
		}
		break;
	//-----------------------------------------------------------
	case (ST_SHOW_TIME_MO)://2 ds
		if  (time_state>200) {ShowTimeMO=state=0;}
		if (key) 
		{
		if (key==KEY_MINUS) {
			if (++ShowTimeMO>=4){
				ShowTimeMO=state=0;
				}
			key=time_state=0;
			}
			else
			ShowTimeMO=state=0;
		}
		break;	
	//-----------------------------------------------------------	
	case (ST_SHOW_ALARM)://2 ds
		if  (time_state>200) {ShowAlarm=state=0;}
		if (key) 		
			key=ShowAlarm=state=0;
		break;	
		
	default:
		state=0;
		break;
	//*/
	}
}

//-------------------------------------
void vlagnost_in_buf(uint8_t *p){
	if ( FlagSHT10 == SHT10_OK ){
		result_in_bcd(Sht10Humi);
		if (Sht10Humi<100){
			p[0]=font[bcd_num3];
			p[1]=font[bcd_num4]; 
			p[2]=sB|sE|sH;
		}else{
			p[0]=font[1];
			p[1]=font[0];
			p[2]=font[0];
			}
		}
	else{
		p[0]=sG;
		p[1]=sG;
		p[2]=sB|sE|sH;
		}
		
}
//-------------------------------------
void show_time_do_action(int16_t *Param, uint8_t Flag, int32_t *time){//time-     0.1s

uint16_t T=(*time)/600;//   
uint16_t S=(*time)/10;//   sek

uint8_t St=0;
if ((Param[0]==0) || (Param[1]==0)) St=1;

	if (StateOutCool & Flag){
		led_buffer[1]=font[f_o];
		led_buffer[2]=font[f_n];
		}
	else{	
	//if (Param){
	if (St==0){
		if (T > 10*60-1){// 10 
			result_in_bcd(T/60);// 
			led_buffer[0]=font[bcd_num3];
			led_buffer[1]=font[bcd_num4]; 
			}
			else//{
		if (S<60){// 
			result_in_bcd(S);
			led_buffer[0]=font[bcd_num3]; 
			led_buffer[1]=font[bcd_num4]; 
			led_buffer[2]=f_c; 
			}
		else{// 10    
			led_buffer[0]=font[T/60]|sH;
			result_in_bcd(T%60);
			led_buffer[1]=font[bcd_num3]; 
			led_buffer[2]=font[bcd_num4]; 
			}
		}
	else{
		led_buffer[0]=font[0];
		led_buffer[1]=font[f_F];
		led_buffer[2]=font[f_F];
		}
	}
		
}


//-------------------------------------
void data_led(void)
{
unsigned char i;

for(i=0;i<sizeof(led_buffer);i++)
	led_buffer[i]=0;

	vlagnost_in_buf(led_buffer_vlag);
	
	switch (state)
	{

    case (ST_SET_T):
		led_buffer[0]=font[f_y];
		led_buffer[1]=font[f_C];
		led_buffer[2]=font[f_t];
		break;
	case (ST_SET_DELTA_T): 
		led_buffer[0]=font[f_P];
		led_buffer[1]=font[f_a];
		led_buffer[2]=font[3];
		break;
	case (ST_SET_DELTA_T_GIST): 
		led_buffer[0]=font[f_P]|sH;
		led_buffer[1]=sA|sF|sE;//
		led_buffer[2]=sG|sE|sD|sH;//.
		break;	
	case (ST_SET_T_ALARM):
		led_buffer[0]=font[f_a];
		led_buffer[1]=font[8];
		led_buffer[2]=font[f_P]|sH;
		break;
	case (ST_POWER_CONST):
		led_buffer[0]=font[f_P];//
		led_buffer[1]=font[f_E];//
		led_buffer[2]=sA|sF|sE|sH;//.
		break;	
	
	case (ST_SET_VLAG):
		led_buffer[0]=font[8];//sC|sD|sE;//u
		led_buffer[1]=sE|sD|sF;
		led_buffer[2]=font[f_a];//sF|sE|sA|sH;
		break;
	case (ST_MANUAL_MOVE):
		led_buffer[0]=font[f_P];
		led_buffer[1]=font[f_y];
		led_buffer[2]=font[4]|sH;
		break;
	case (ST_SET_VLAG_T_ON)://  
		led_buffer[0]=font[f_t]|sH;
		led_buffer[1]=font[f_o]; 
		led_buffer[2]=font[f_n];
		break;
	case (ST_SET_VLAG_PAUSE)://  
		led_buffer[0]=font[f_t]|sH;//font[f_P];
		led_buffer[1]=font[f_o];//font[f_a]; 
		led_buffer[2]=font[f_F];//font[f_U];
		break;
	case (ST_VLAG_DOWN)://  
		led_buffer[0]=font[f_Pr];//
		led_buffer[1]=font[f_P];// 
		led_buffer[2]=font[f_E];//
		break;	
		
	case (ST_COR_IN_DS0)://   
	case (ST_COR_IN_DS1)://    ds2
	case (ST_COR_IN_DS2)://    ds2
		led_buffer[0]=sG;
		led_buffer[1]=font[state-(ST_COR_IN_DS0-1)];
		led_buffer[2]=sG;
		break;
	
	case (ST_SET_T_1)://  
	case (ST_SET_DELTA_T_EDIT)://   
	case (ST_SET_T_ALARM_1):
	//case (ST_SET_VLAG_POROG)://  
	case (ST_POWER_CONST_1)://   .
		if ( !blank )
		{
		result_in_bcd(tmp_int16);
		led_buffer[0]=font[bcd_num2];
		led_buffer[1]=font[bcd_num3]; 
		if (state!=ST_POWER_CONST_1) led_buffer[1]|=sH;
			#ifdef LOW_PWM
			else led_buffer[0]|=sH;
			#endif
		led_buffer[2]=font[bcd_num4]; 
		}
		break;
	
	case (ST_TIM_OHLAGD_EDIT)://  
		if ( !blank )
		{
		result_in_bcd(tmp_int16);
		led_buffer[1]=font[bcd_num3];
		led_buffer[2]=font[bcd_num4]; 
		}
		break;
	
	case (ST_VLAG_DOWN_1):
	case (ST_SET_VLAG_POROG)://  
		if ( !blank )
		{
		result_in_bcd(tmp_int16);
		led_buffer[0]=font[bcd_num3];
		led_buffer[1]=font[bcd_num4]; 
		}
		led_buffer[2]=sB|sE; 
		break;
	
	case (ST_MANUAL_MOVE_1)://  
		#if (defined (AKTUATOR)||defined (KSHM))
		led_buffer[1]=sA|sD;
		if (  Outs_HC595 & OUT_MOTOR ) 
			led_buffer[0]=font[1];//sA|sF|sE|sD;
			else
			led_buffer[2]=font[0];//sA|sB|sC|sD;
		break;
		#endif
	case (ST_VLAG_WORK_EDIT)://    
		if ( !blank )
		{
		if (state==ST_MANUAL_MOVE_1)
		result_in_bcd(tmp_int16/10);
		else
		result_in_bcd(tmp_int16);
		led_buffer[0]=font[bcd_num2];
		led_buffer[1]=font[bcd_num3]; 
		led_buffer[2]=font[bcd_num4];
		}	
		break;
	case (ST_MANUAL_MOVE_2):
		break;
	
	case (ST_TIM_OFF_1):	//    
		if ( !blank )
		{
		if (tmp_int16){ 
			led_buffer[0]=font[tmp_int16/60]|sH;
			result_in_bcd(tmp_int16%60);
			led_buffer[1]=font[bcd_num3]; 
			led_buffer[2]=font[bcd_num4]; 
			}
			else{
			led_buffer[0]=font[0];
			led_buffer[1]=font[f_F];
			led_buffer[2]=font[f_F];
			}
		}
		break;
		
	case (ST_TIM_OFF):
		led_buffer[0]=font[f_d]|sH;//font[f_F];font[0];
		led_buffer[1]=font[0];//font[f_F];
		led_buffer[2]=font[f_F];//font[f_F];
		break;

	case (ST_TIM_PROV_ON)://  ( )
		led_buffer[0]=font[f_Pr]|sH;//.
		led_buffer[1]=font[f_o];
		led_buffer[2]=font[f_n];
		break;	
	case (ST_TIM_PROV_OFF)://  ( )
		led_buffer[0]=font[f_Pr]|sH;//.
		led_buffer[1]=font[f_o];
		led_buffer[2]=font[f_F];
		break;
	case (ST_TIM_OHLAGD_ON)://  ( )
		led_buffer[0]=font[0]|sH;//.
		led_buffer[1]=font[f_o];
		led_buffer[2]=font[f_n];
		break;	
	case (ST_TIM_OHLAGD_OFF)://  ( )
		led_buffer[0]=font[0]|sH;//.
		led_buffer[1]=font[f_o];
		led_buffer[2]=font[f_F];
		break;	
	case (ST_TIM_OHLAGD_TEMPER)://  ( )
		led_buffer[0]=font[0]|sH;//.
		led_buffer[1]=font[f_t];
		led_buffer[2]=f_gr;
		break;	
	//case (ST_COR_1):
	case (ST_COR_2)://   
		if ( !blank )
		{
		if (tmp_int16<0){
			result_in_bcd(tmp_int16*-1);
			led_buffer[0]=sG;
			}
			else
			result_in_bcd(tmp_int16);
		led_buffer[1]=font[bcd_num3]|sH; 
		led_buffer[2]=font[bcd_num4]; 
		}
		break;
	
	case (ST_SHOW_VLAGNOST)://
		if (show_vlagnost==1){
			vlagnost_in_buf(led_buffer);
			}
			else
			if (show_vlagnost==2){
			t_in_bcd(Temp_DS1,PWIRE_1);
			//led_buffer[1]|=sH;
			led_buffer[2]|=sH;
			}
			else
			{
			t_in_bcd(Temp_DS2,PWIRE_2);
			led_buffer[0]|=sH;
			led_buffer[2]|=sH;
			}
		break;
		
	case (ST_SHOW_TIME_MO):
		{
		if (ShowTimeMO==1){//     
				if ( state_motor==1 || state_motor==2){//dhtvz 
					#if defined (REVERS_RELE)
					led_buffer[1]=font[f_o];
					led_buffer[2]=font[f_n];
					#elif defined (AKTUATOR) // 
					show_time_do_action(&setup.time_lotok_pause, 0, &Time_Motor);
					#elif defined (KSHM) // - 

					#else	//  
					led_buffer[1]=font[f_o];
					led_buffer[2]=font[f_n];
					#endif
					}
				else{
					#if defined (REVERS_RELE)
					show_time_do_action(&setup.time_lotok_pause, 0, &Time_Motor);
					#elif defined (AKTUATOR) // 
					show_time_do_action(&setup.time_lotok_pause, 0, &Time_Motor);
					#elif defined (KSHM) // - 
					if (  Outs_HC595 & OUT_MOTOR ){
						led_buffer[1]=font[f_o];
						led_buffer[2]=font[f_n];
						}
						else
						show_time_do_action(&setup.time_lotok_pause, 0, &Time_Motor);
					#else	//  
					show_time_do_action(&setup.time_lotok_pause, 0, &Time_Motor);
					#endif
					}
				if ( time_state & _BV(2) ) led_buffer[2]|=sH;
			}
			else
			if (ShowTimeMO==2){//    
				show_time_do_action(&setup.TimeOnProvetrivanie, VL_PROVETRIVANIE, &Time_Provetrivanie);
				if ( time_state & _BV(2) ) led_buffer[1]|=sH;
			}
			else//    
			{
				show_time_do_action(&setup.TimeOnOhlagdenie, VL_OHLAGDENIE, &Time_Ohlagdenie);
				if ( time_state & _BV(2) ) {
					led_buffer[1]|=sH;
					led_buffer[2]|=sH;
					}
			}
		break;	
		}
		
	case (ST_SHOW_ALARM):{//
		static uint8_t tim;
		//if (time_state & _BV(0)) tim++;
		if (++tim>40)
		{
		tim=0;
		if ((ShowAlarm<1) && (alarm_T & ALRM_HI_T) ){ 
			ShowAlarm=1;//alarm 1
			}
		else
		if ((ShowAlarm<2) && (alarm_T & ALRM_EEP) && ( eeprom_err!=1 ) ){ 
			ShowAlarm=2;//alarm 2
			}
		else
		if ((ShowAlarm<3) && (alarm_T & ALRM_SENS) ){ 
			ShowAlarm=3;//alarm 3
			}
		else
		if ((ShowAlarm<4) && (alarm_T & ALRM_DFRN_T) ){
			ShowAlarm=4;//alarm 4
			}
		else
		if ((ShowAlarm<5) && (alarm_T & ALRM_LOW_T)  ){ 
			ShowAlarm=5;//alarm 5
			}
		else
		if ((ShowAlarm<6) && (alarm_T & ALRM_SWT_ERROR) ){
			ShowAlarm=6;//alarm 6
			}
		else
		if ((ShowAlarm<7) && (alarm_T & ALRM_HUMIDY_LOW) ){
			ShowAlarm=7;//alarm 7
			}
		else
		if ((ShowAlarm<8) && (alarm_T & ALRM_REG_ALARM_RELE) ){
			ShowAlarm=8;//alarm 7
			}
		else
		ShowAlarm=0;
		}
		
		led_buffer[0]=font[f_a];
		if (ShowAlarm)
			led_buffer[1]=font[ShowAlarm];
		else
		if (alarm_T==0) led_buffer[1]=sG;
		
		break;
		}
	
    default:
		if ( eeprom_err==1 ){
			led_buffer[0]=sE|sD|sF;//L
			led_buffer[1]=font[f_C];//C
			led_buffer[2]=sA|sB|sG|sF;//`
			}
		else
		if ( eeprom_err>1 ){
			led_buffer[0]=font[f_E];
			led_buffer[1]=font[f_E];
			led_buffer[2]=font[f_P];
			}
		else{
			if ( out_1wire & PWIRE_0 )
				t_in_bcd(Temp_DS0,PWIRE_0);
				else{
				t_in_bcd(Temp_DS1,PWIRE_1);
				led_buffer[2]|=sH;
				}
			}
		break;
	}

}
//-------------------------------------


int main(void)
{
uint8_t tim_led=4, tim_0_01_sek=10, tim_motor=50, spolzanie_swt=1, st_motor_on=0, tim100ms=100, time_alarm=1;
//-------------
	
	cli();
	clock_prescale_set(clock_div_2);
//#define TEST	D,0,H
//DRIVER(TEST,OUT);
//#define TESTIMP	{ON(TEST);OFF(TEST);}

	
	avr_init();
	UART_init();
	
	read_data_EEPROM();
	TriacGate=TRIAC_OFF;
	
	detectPresence();
	if (out_1wire){
		writebyte(0xCC);//SKIP ROM [CCh]
		writebyte(0x4E);//WRITE SCRATCHPAD [4Eh]
		writebyte(0);//	TH
		writebyte(0);//	TL
		writebyte(0x7F);//	20 Statys 10bit //writebyte(0x60);//	Statys 12bit byte 4 Configuration Register* 0x7F - 12 bit 750mSek; 1F-9bit 94msek
		}
	
	// 
	//cli();
	wdt_enable(WDTO_30MS);//wdt_reset();//asm("wdr");//  
	sei();
	
	
while(1)
{
if (TIFR1 & _BV(OCF1A)) // 0.001 sek
	{
	TIFR1 = _BV(OCF1A);

	if ( --tim_led==0 )// 
		{
		tim_led=4;
		led_off();//  
		wdt_reset();//asm("wdr");//  
		skan_key();
		key_action();
		if (++znmesto<3)
			{
			led_on();// . 
			hc595_out();
			}
			else
			{
//TESTIMP;
			znmesto=0xFF;
			tim_led=1;// 
			data_led();
			receive_t();//		
//TESTIMP;
			}
		
		}
	//----------------------------------1mSek-----------------------------------------

	//----------=----------------------0.01-Sek---------------------------------------
	if ( --tim_0_01_sek==0 )	//0.01sek
		{
		tim_0_01_sek=10;
		
		//-----------------------------------------------------------------------
		#ifdef LOW_PWM
		//---------------__-----------------
		if (status_nagrev!=5)
		//if (status_nagrev==0)
		{
		if ( lpwm_out() ) {
			TriacGate=TRIAC_ON;
			Outs_HC595|=OUT_ON_NAGREV;
			Outs_HC595 &= ~OUT_SILOVOE_RELE;//if (status_nagrev==4) 
			}
			else{
			TriacGate=TRIAC_OFF;
			Outs_HC595&=~OUT_ON_NAGREV;
			if (status_nagrev==4) Outs_HC595 |= OUT_SILOVOE_RELE;
			}
		}
		#else
		//-----------------------------------------------------------------------
		
		//------__----------
		if (status_nagrev==3)
		{
		if ( power_flag==T_TOP ){//
			if ( TriacGate<MAX_LENGTH_REG ) TriacGate++; else {TriacGate=TRIAC_OFF; power_flag=NAGREV_OFF;}
			}
		else
		if ( power_flag==T_BOTTOM ){	//  TriacGate  tmp_power 
				uint8_t p=TriacGate;
				if ( p>tmp_power ) p--; 
				else 
				if ( p<tmp_power ) p++; 
				TriacGate=p;
			}
		}
		#endif
		//-------___------------
		if (--time_blank==0)
			{
			if ( blank )
				{//   
				blank=0;
				time_blank=50;//0.5sek
				}
			else
				{
				blank=1;
				time_blank=20;
				}
			}
		if ( antdr ){
				blank=0;
				time_blank=10;
				}
		
		/*if (hc595!=Outs_HC595)
			{
			hc595=Outs_HC595;
			hc595_out();
			}*/
		}
	
	//------------------------------1mSek----------------------------------
	#if defined (REVERS_RELE)
	if (state_motor==0){ //  
		tim_motor=100;
		st_motor_on=0;// 0     1- , 2-
		}
		else
		if (state_motor==1){//  
			if (st_motor_on==0)
				{
				Outs_HC595 &= ~OUT_MOTOR_REVERS;
				Outs_HC595 |= OUT_MOTOR;
				tim100ms=100;//  ()   
				st_motor_on=1;
				spolzanie_swt=1;
				}
			}
		else
		if (state_motor==2){//  + 
			if (st_motor_on==0)
				{
				Outs_HC595 |= OUT_MOTOR_REVERS;
				if (--tim_motor==0){
					Outs_HC595 |= OUT_MOTOR;
					tim100ms=100;
					st_motor_on=2;
					spolzanie_swt=2;
					}
				}
			}
		else
		if (state_motor==3){//
			Outs_HC595 &= ~OUT_MOTOR;
			tim_motor=100;
			st_motor_on=0;
			state_motor=4;
			}
		else
		if (state_motor==4){//
			if ( Outs_HC595 & OUT_MOTOR_REVERS ) 
				{
				if (--tim_motor==0){//100  
					Outs_HC595 &= ~OUT_MOTOR_REVERS;
					state_motor=0;
					}
				}else{
				Outs_HC595 &= ~OUT_MOTOR_REVERS;//  ,   .    
				state_motor=0;
				}
			}
		else
		state_motor=0;
	//----------------------------------------------------------------------------------------------
	#elif defined (AKTUATOR) // 
	//----------------------------------------------------------------------------------------------
	if (state_motor==1){//  
		Outs_HC595 |= OUT_MOTOR;
		}
	else
	if (state_motor==2){//  + 
		Outs_HC595 &= ~OUT_MOTOR;
		}
	else	
	if (state_motor>=3){// 
		state_motor=0;// ,     .  
		}
	//----------------------------------------------------------------------------------------------
	#elif defined (KSHM) // - 
	//----------------------------------------------------------------------------------------------
	if (state_motor==1){//  
		Outs_HC595 |= OUT_MOTOR;
		spolzanie_swt=1;
		state_motor=0;// ,     .  
		}
		else
	if (state_motor==3){// 
		Outs_HC595 &= ~OUT_MOTOR;
		state_motor=0;// ,     .  
		}
	//----------------------------------------------------------------------------------------------
	#else	//  
	//----------------------------------------------------------------------------------------------
	if (state_motor==0){ //  
		Outs_HC595 &= ~OUT_MOTOR;
		Outs_HC595 &= ~OUT_MOTOR_REVERS;
		st_motor_on=0;// 0     1- , 2-
		}
		else
		if (state_motor==1){//  
			if (st_motor_on==0)
				{
				Outs_HC595 |= OUT_MOTOR;
				tim100ms=100;//  ()   
				st_motor_on=1;
				spolzanie_swt=1;
				}
			}
		else
		if (state_motor==2){//  + 
			if (st_motor_on==0)
				{
				Outs_HC595 |= OUT_MOTOR_REVERS;
				tim100ms=100;
				st_motor_on=2;
				spolzanie_swt=2;
				}
			}
		else
		if (state_motor==3){//
			state_motor=0;
			}
		else
		state_motor=0;
	#endif
	
	//--------------------------------0.1_Sek------------------------------------
	if ( --tim100ms==0 )	//0.1sek
		{
		tim100ms=100;
		
		time_wire--;	//   
		time_state++;	//      
		
		//-------    ---------------------
		if (on_out_vlagnost){
			if (--time_vlagnost<=0){
				if (Outs_HC595 & OUT_VLAG){
					time_vlagnost=setup.TimePauseVlagnost;
					if (time_vlagnost) Outs_HC595 &= ~OUT_VLAG;//      ,   
					}else{
					Outs_HC595|=OUT_VLAG;
					time_vlagnost=setup.TimeOnVlagnost;
					}
				}
			}else{
			time_vlagnost=0;
			Outs_HC595 &= ~OUT_VLAG;
			}
		//-------------  -------------------
		//  OUT_DAMAGE_COOL
		if ( --Time_Provetrivanie<=0 ){
			if (StateOutCool & VL_PROVETRIVANIE){//
				StateOutCool&=~VL_PROVETRIVANIE;//  ,  
				if (setup.TimePauseProvetrivanie){
					Time_Provetrivanie=(int32_t)setup.TimePauseProvetrivanie*60*10;//    
					//Time_Provetrivanie=(int32_t)setup.TimePauseProvetrivanie*10;//    
					}
					else Time_Provetrivanie=1*60*10;// ==0,    1
				
				if ( (StateOutCool & (VL_DAMAGE_COOL|VL_OHLAGDENIE|VL_LARGE_VLAG))==0 ) Outs_HC595&=~OUT_DAMAGE_COOL;
				}
			else{//  
				if	( setup.TimeOnProvetrivanie && setup.TimePauseProvetrivanie && //     
					((StateOutCool & (VL_DAMAGE_COOL|VL_OHLAGDENIE))==0) )//        
					{//  .
					Time_Provetrivanie=(int32_t)setup.TimeOnProvetrivanie*10;//    
					StateOutCool|=VL_PROVETRIVANIE;
					Outs_HC595|=OUT_DAMAGE_COOL;
					}
					else Time_Provetrivanie=1*60*10;// ==0,    1
				}
			}
		//-------------  -------------------
		//  OUT_DAMAGE_COOL
		if ( --Time_Ohlagdenie<=0 ){
			if (StateOutCool & VL_OHLAGDENIE){
				StateOutCool&=~VL_OHLAGDENIE;//  ,  
				if (setup.TimePauseOhlagdenie){
					Time_Ohlagdenie=(int32_t)setup.TimePauseOhlagdenie*60*60*10;//    
					//Time_Ohlagdenie=(int32_t)setup.TimePauseOhlagdenie*10;//   sek
					}
					else Time_Ohlagdenie=1*60*10;// ==0,    1
				
				if ( (StateOutCool & VL_DAMAGE_COOL)==0 ) {
					Outs_HC595&=~OUT_DAMAGE_COOL;
					if (Avaria==0)
						status_nagrev=0;//   . 
						else
						status_nagrev=4;
					}
				}
			else{
				if (setup.TimeOnOhlagdenie && setup.TimePauseOhlagdenie){//  
					Time_Ohlagdenie=(int32_t)setup.TimeOnOhlagdenie*60*10;//    
					//Time_Ohlagdenie=(int32_t)setup.TimeOnOhlagdenie*10;//    sek
					StateOutCool|=VL_OHLAGDENIE;
					if ( (Temp_DS1 > setup.TemperatureOhlagdenie) || (Temp_DS0 > setup.TemperatureOhlagdenie) ) Outs_HC595|=OUT_DAMAGE_COOL;
					status_nagrev=5;//   . 
					}
					else Time_Ohlagdenie=1*60*10;// ==0,    1
				}
			}
			
		//-------      35..40.5 --------
		if ( alarm_T )
			{
			if ( --time_alarm == 0 )
				{
				if ( Outs_HC595 & OUT_ZUMER ){
					Outs_HC595 &= ~OUT_ZUMER;
					//  
					if (alarm_T & ALRM_REG_ALARM_RELE) 	time_alarm=30;//alarm 8
					if (alarm_T & ALRM_HUMIDY_LOW) 	time_alarm=25;//alarm 7
					if (alarm_T & ALRM_SWT_ERROR) 	time_alarm=25;//alarm 6
					if (alarm_T & ALRM_LOW_T) 	time_alarm=20;//alarm 5
					if (alarm_T & ALRM_DFRN_T)	time_alarm=50;//alarm 4
					if (alarm_T & ALRM_SENS)	time_alarm=25;//alarm 3
					if (alarm_T & ALRM_EEP) 	time_alarm=25;//alarm 2
					if (alarm_T & ALRM_HI_T) 	time_alarm=5;//alarm 1
					}
					else{
					Outs_HC595 |= OUT_ZUMER;
					//  
					if (alarm_T & ALRM_REG_ALARM_RELE)	time_alarm=10;
					if (alarm_T & ALRM_HUMIDY_LOW) 	time_alarm=15;//alarm 7
					if (alarm_T & ALRM_SWT_ERROR)	time_alarm=15;
					if (alarm_T & ALRM_LOW_T)	time_alarm=5;
					if (alarm_T & ALRM_DFRN_T)	time_alarm=5;
					if (alarm_T & ALRM_SENS)	time_alarm=15;
					if (alarm_T & ALRM_EEP)		time_alarm=15;
					if (alarm_T & ALRM_HI_T)	time_alarm=5;
					}
				}
			}
			else {time_alarm=1; Outs_HC595 &= ~OUT_ZUMER;}
		
		//  
		if ( swt_konzevik == (SWT_F_KONZEVIK|SWT_R_KONZEVIK) ) {//    !
			alarm_T|=ALRM_SWT_ERROR;
			}
			//else
			//alarm_T&=~ALRM_SWT_ERROR;
		
		/*  ,     ,   .       
		       .
		*/
		#if defined(AKTUATOR) // 
		if ( --Time_Motor<=0 ){
			if (setup.time_lotok_pause){
				Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  
				if (  Outs_HC595 & OUT_MOTOR )
					state_motor=2;//  ,     state_motor
					else
					state_motor=1;//on motor
				}
			else{
				//state_motor=2;// ,             (        )
				Time_Motor=10;//    ,   setup.time_lotok_pause   
				}
			}
		#else
		//END defined(AKTUATOR)
		//---------- -----------
		if (state==ST_MANUAL_MOVE_1)
			{
			if (st_motor_on==1){
				tmp_int16++;
				}
			else
			if (st_motor_on==2){
				if (tmp_int16) tmp_int16--; 
				}
			}
		else
		{
		//---------- -------------
		
		//--------------------------------------
		#if defined (KSHM) // - 
		//   ,    
		//   .
		if (swt_konzevik){// ,      
			if (  Outs_HC595 & OUT_MOTOR ) //  
				if (spolzanie_swt==0) //     (  spolzanie_swt>0)    
					Time_Motor=1; // .
			}
			else
			spolzanie_swt=0;
			
		if ( --Time_Motor<=0 ){
			if (  Outs_HC595 & OUT_MOTOR ) //  
				{
				state_motor=3;//
				Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  
				}
			else
				{
				//_ 
				//   
				if (setup.time_lotok_pause){//    
					state_motor=1;//on
					Time_Motor=30*60*10;//   ( ) 30min
					}
					else{
					state_motor=3;//
					Time_Motor=10;// 1,    
					}
				}
			}

		//--------------------------------------
		#else //END if defined (KSHM)
		
		if (swt_konzevik){
			if ( swt_konzevik == (SWT_F_KONZEVIK|SWT_R_KONZEVIK) ) {
				spolzanie_swt=0;//    !      
				}

			#ifdef REVERS_RELE
			if (  Outs_HC595 & OUT_MOTOR ) //  
			#else
			if ( (Outs_HC595 & OUT_MOTOR)||(Outs_HC595 & OUT_MOTOR_REVERS) ) //  
			#endif
				if (spolzanie_swt==0) //     (  spolzanie_swt>0)   
					Time_Motor=1; // .
			}
			else
			spolzanie_swt=0;
			
		if ( --Time_Motor<=0 ){
			if ( swt_konzevik & SWT_F_KONZEVIK ) revers=0;//   ( ) -   
			if ( swt_konzevik & SWT_R_KONZEVIK ) revers=1;

			#ifdef REVERS_RELE
			if (  Outs_HC595 & OUT_MOTOR ) //  
			#else
			if ( (Outs_HC595 & OUT_MOTOR)||(Outs_HC595 & OUT_MOTOR_REVERS) ) //  
			#endif
				{
				state_motor=3;//
				Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//  
				if ( swt_konzevik == (SWT_F_KONZEVIK|SWT_R_KONZEVIK) ) //     
					setup.time_lotok_pause=0;
				}
			else
				{
				// 
				#ifdef LOTOK_ONE_SW
				//   
				//if ( swt_konzevik != (SWT_F_KONZEVIK|SWT_R_KONZEVIK) ) //     
				if (setup.time_lotok_pause){//    
					state_motor=1+revers;
					revers^=_BV(0);
					Time_Motor=(int32_t)setup.time_lotok_pause*60*10;//   ( )
					}
				#else
				//   (    )
				//if (setup.time_lotok_pause && setup.time_lotok_on && (swt_konzevik != (SWT_F_KONZEVIK|SWT_R_KONZEVIK)) ){//     //if (setup.time_lotok_on){//    
				if (setup.time_lotok_pause && setup.time_lotok_on){//     //if (setup.time_lotok_on){//    
					state_motor=1+revers;
					revers^=_BV(0);
					Time_Motor=setup.time_lotok_on;
					}
					else{//    ,    
					Time_Motor=100;//  
					state_motor=3;//
					}
				#endif
				}
			}
		#endif//END #else defined (KSHM)
		}
		#endif//END #else defined (AKTUATOR)
		//----------------------------------------
		}
	//-------------------------------------------------------------
	}
}

}

